﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using Infragistics.Windows.DataPresenter;

namespace CellDisableStyle
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        DataTable dtData;

        public MainWindow()
        {
            InitializeComponent();
            dtData = new DataTable();
            dtData.Columns.Add("Column1");
            dtData.Columns.Add("Column2");
            dtData.Columns.Add("Column3");
            dtData.Columns.Add("Column4");
            xdgData.DataSource = dtData.DefaultView;
        }

        private void btnPopulateData_Click(object sender, RoutedEventArgs e)
        {
            int c = 3;
            for (int i = 0; i < 4; i++)
            {
                //DataRow dr = dtData.NewRow();
                ////if (i == 3)
                ////{ dr[0] = 0; }
                ////else
                ////{ dr[0] = 1; }
                //dr[0] = c;
                //dr[1] = c + 1;
                //dr[2] = c + 2;
                //dr[3] = c + 3;
                //dtData.Rows.Add(dr);
                //c--;

                DataRecord record = xdgData.RecordManager.CurrentAddRecord;
                //if (i == 3)
                //    record.Cells[0].Value = 0;
                //else if (i == 2)
                //    record.Cells[0].Value = 2;
                //else
                //    record.Cells[0].Value = 1;
                record.Cells[0].Value = i;
                record.Cells[1].Value = i + 1;
                record.Cells[2].Value = i + 2;
                record.Cells[3].Value = i + 3;
                xdgData.RecordManager.CommitAddRecord();
            }            
            //xdgData.ExecuteCommand(DataPresenterCommands.CommitChangesToActiveRecord);
        }
    }

    public class FormatValueConverter : IMultiValueConverter
    {
        #region "IValueConverter Members"

        public Object Convert(Object[] values, Type targetType, Object parameter, System.Globalization.CultureInfo culture)
        {
            if ((bool)values[2])
            {
                return true; 
            }
            int num;
            try
            {
                num = System.Convert.ToInt32(values[0]);
            }
            catch
            {
                return true;
            }

            if (num == 1)
            {
                return false;
            }
            else if (num == 2 || num == 3)
            {
                return true;
            }
            else if (num == 0)
            {
                if (values[1].ToString() == "Column4")
                    return false;
                else
                    return true;
            }

            return true;
        }

        public Object[] ConvertBack(Object value, Type[] targetTypes, Object parameter, System.Globalization.CultureInfo culture)
        {
            string[] splitValues = ((string)value).Split(' ');
            return splitValues;
        }

        #endregion
    }
}